/* For free support for VSIDE, please visit www.vsdsp-forum.com */

// Starting point template for creating VSOS3 applications.
// This will create a <projectname>.AP3 file, which you can copy to 
// your VS1005 Developer Board and run it from there.

// AP3 files require VSOS3 kernel 0.3x to run.

// If you rename your application to INIT.AP3, then the kernel will
// load it automatically after booting.

#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <consolestate.h>
#include <string.h>

u_int32 fopen_save;

#define CMD_LINE_CHARS 256

char currentDirectoryBuf[128];
char cmd[CMD_LINE_CHARS] = {CMD_LINE_CHARS};

VO_FILE *(*old_fopen)(const char *filename, const char *mode);

VO_FILE *CurDirFOpen(const char *filename, const char *mode) {
	static char fn[128];
	//printf("CDF(%s,%s)\n",filename,mode);
	//if (filename[0]=='.') filename+=2;
	if ((filename[1]==':') && (filename[2] == '/' || filename[2] == '\\' )) {
		strcpy(&filename[2],&filename[3]);
	}
	if (filename[1]==':') return old_fopen(filename, mode);
	sprintf(fn,"%s%s",currentDirectoryBuf,filename);
	//printf("CDN(%s,%s)\n",fn,mode);
	return old_fopen(fn, mode);	
}


void init(void) {
	fopen_save = ReadIMem(vo_fopen);
	old_fopen = fopen_save>>6L;
	SetHandler(vo_fopen, CurDirFOpen); 	
}
 
ioresult main(char *parameters) {
	currentDirectory = currentDirectoryBuf;
	appFlags = APP_FLAG_ECHO;	
	strcpy(currentDirectory,"S:");
	printf("\nVSOS SHELL\n");
	while (1) {
		char *params = cmd+1;
		RunLibraryFunction("GETCMD",ENTRY_MAIN,(int)cmd);
		while (*params) {
			if (*params==' ') {
				break;
			}
			++params;
		}
		while (*params==' ') {
			*params++ = '\0';
		}
		RunLibraryFunction(cmd+1,ENTRY_MAIN,(int)params);
	}
}

void fini(void) {
	WriteIMem(vo_fopen, fopen_save);
}
